<!DOCTYPE html>
<html>

<head>
    <title>INF226</title>
    <link rel="stylesheet" href="highlight.css" />
	<link rel="icon" href="favicon.png" type="image/png" />

    <style>
        * {
            box-sizing: border-box;
            ;
        }

        #logoutBtn {
            float: right;
        }
        #clearBtn {
            float: right;
        }

        #page {
            height: 90vh;
            display: flex;
            flex-direction: column;
            ;
            padding: .5rem;
        }

        main {
            border-top: 1px solid grey;
            border-bottom: 1px solid grey;
            /* min-height: 50%; */
            flex-grow: 1;
            flex-shrink: 1;
            overflow:auto;
        }

        body {
            margin: 0;
        }

        label {
            justify-self: end;
            ;
        }

        #controls {
            /* min-height: 20%; */
            font-size: 1.4rem;
            display: grid;
            grid-template-columns: 1fr 6fr 1fr 1fr ;
            grid-auto-rows: 1.4rem;
            ;
            grid-gap: .5rem;
            max-width: 100rem;

        }

        #output {
            width: 100%;
            height: 100%;
            background: #eee;
            overflow: auto;
            margin: 0;
        }
        #output p {
            border-bottom: 1px solid grey;
            padding-bottom: .25rem;
        }
        #header {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
        }

        #header li {
            display: block;
            font-style: italic;
            font-size: 1.2rem;
            padding: .25rem;
            margin:0 1rem;
        }
    </style>

</head>

<body>
    <header >
        <div></div>
        <a href="/logout"><button type="button" id="logoutBtn">Log out</button></a>
        <a href="/index.html"><button type="button" id="clearBtn">Clear log</button></a>
        <h3 id="nameHeader">Logged in as: </h2>
        
    </header>
    <div id="page">
        <marquee>
            <div id="header"></div>
        </marquee>
        <main>
            <pre id="output"></pre>
        </main>
        <div id="controls">
            <label for="search">Search:</label>
            <input type="search" id="search" name="search" enterkeyhint="search" value="*">
            <button type="button" id="searchBtn">Search!</button>
            <button type="button" id="allBtn">Show all</button>
            <label for="recipient">To:</label>
            <input type="text" id="recipient" name="recipient" placeholder="Recipient">
            <button type="button" id="allBtn2">Show all*</button>
            <input type="text" id="messageID" name="messageID" placeholder="1">
            <label for="message">Message:</label>
            <textarea id="message" style="grid-row: span 4;" placeholder="A message..."></textarea>
            <button type="button" id="sendBtn">Send</button>
            <button type="button" id="messageIDbtn">Lookup msg ID</button>
        </div>
        <div id="anchor"></div>
    </div>
</body>
<script>
    var reqId = 0;
    let usernameNow = document.getElementById('nameHeader')
    let messageByID = document.getElementById('messageID')
    let messageIDbtn = document.getElementById('messageIDbtn')
    var anchor = document.getElementById('anchor');
    var searchField = document.getElementById('search');
    var messageField = document.getElementById('message');
    var recipientField = document.getElementById('recipient');
    var searchBtn = document.getElementById('searchBtn');
    var sendBtn = document.getElementById('sendBtn');
    var allBtn = document.getElementById('allBtn');
    var allBtn2 = document.getElementById('allBtn2');
    var output = document.getElementById('output');
    var header = document.getElementById('header');
    var logout = document.getElementById('logoutBtn');
    
    var checkAnnouncements = async () => {
        res = await fetch('/announcements');
        anns = await res.json();
        if (anns && Array.isArray(anns.data)) {
            const elts = [];
            anns.data.forEach((element, idx) => {
                if (idx > 0) {
                    const node = document.createElement('li');
                    node.textContent = '  …  ';
                    elts.push(node);
                }
                const node = document.createElement('li');
                node.textContent = `${element.message || ''}`;
                elts.push(node);
            });
            console.log(elts);
            header.replaceChildren(...elts);
        }
    };
    var search = async (query, typ) => {
        const id = reqId++;
        const q = `/search?q=${encodeURIComponent(query)}&type=${typ}`;
        res = await fetch(q);
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };
    var send = async (message, recipient) => {
        const id = reqId++;
        const q = `/send?message=${encodeURIComponent(message)}&recipient=${encodeURIComponent(recipient)}`;
        res = await fetch(q, { method: 'post' });
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };
    var getname = async () => {
        const id = reqId++;
        const q = `/getUsername`;
        res = await fetch(q);
        console.log(res)
        user = await res.text()
        usernameNow.innerHTML += user
    };
    searchField.addEventListener('keydown', ev => {
        if (ev.key === 'Enter') {
            search(searchField.value);
        }
    });

    searchBtn.addEventListener('click', () => search(searchField.value));
    allBtn.addEventListener('click', () => search('*'));
    allBtn2.addEventListener('click', () => search('legitAll'));
    sendBtn.addEventListener('click', () => send(messageField.value, recipientField.value));
    messageIDbtn.addEventListener('click', () => search(messageByID.value, "int"));
    document.onload = getname();
    checkAnnouncements();
</script>

</html>